=== debian/changelog ===
ansible-base (2.10.5+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Upload to unstable.

 -- Lee Garrett <debian@rocketjump.eu>  Wed, 10 Feb 2021 01:09:15 +0100

ansible-base (2.10.4-1) experimental; urgency=medium

  * Initial packaging of ansible-base (split out at upstream from ansible)
  * Switch from python3-crypto to python3-pycryptodome (Closes: #971309)
  * Bump Standards-Version to 4.5.1 (no changes needed)

 -- Lee Garrett <debian@rocketjump.eu>  Sat, 09 Jan 2021 23:14:43 +0100
