=== debian/rules ===
#!/usr/bin/make -f

DOPACKAGES = $(shell dh_listpackages)
export PYBUILD_DESTDIR=debian/tmp

# Make it easier to build one machines with ansible << 2.10 installed.
export ANSIBLE_SKIP_CONFLICT_CHECK=1

%:
#	dh $@ --with python3,sphinxdoc --buildsystem=pybuild
	dh $@ --with python3 --buildsystem=pybuild

override_dh_clean:
	dh_clean \
		--exclude=test/units/inventory_test_data/group_vars/noparse/all.yml~ \
		--exclude=test/integration/targets/collections/collection_root_user/ansible_collections/testns/testcoll/plugins/modules/uses_leaf_mu_flat_import.bak

#override_dh_auto_build:
#	dh_auto_build
#ifneq (,$(filter ansible-doc,$(DOPACKAGES)))
#	# html documentation
#	$(MAKE) webdocs
#	# manpage documentation
#	$(MAKE) docs
#endif

override_dh_auto_test:
	# For now, disable the tests
	#make tests-nonet

override_dh_python3:
	dh_python3 --shebang=/usr/bin/python3

execute_after_dh_auto_install:
	find debian/tmp/usr/lib/ -name '.git*' -delete
	find debian/tmp/usr/lib/ -name '.travis.yml' -delete
