=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg//,repacksuffix=+dfsg \
https://pypi.debian.net/ansible-base/ ansible-base-(2\.10\.[0-9]+).tar.gz
